/*
 * Copyright (c) 1996 Cygnus Support
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by Per Bothner <bothner@cygnus.com>, October 1996.
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "errors.h"

/*
 * Malloc some memory, throwing an exception if we can't get it.
 * We should perhaps try a spot of GC if we fail first.
 */
void*
checked_malloc(size_t size)
{
	void* ptr;

	ptr = malloc (size);
	if (ptr == 0) {
		throwException(OutOfMemoryError);
	}
	return (ptr);
}

/*
 * Calloc some memory, throwing an exception if we can't get it.
 * We should perhaps try a spot of GC if we fail first.
 */
void*
checked_calloc(size_t nelem, size_t elsize)
{
	void* ptr;

	ptr = calloc (nelem, elsize);
	if (ptr == 0) {
		throwException(OutOfMemoryError);
	}
	return (ptr);
}
